#include <string.h>

#include "architectures.h"

enum Architecture parse_arch(const char *arch) {
    if (!arch)
        return ARCH_NATIVE;

    if (!strncmp(arch, "x86_64", 6)) {
        return ARCH_X86_64;
    }

    return ARCH_NATIVE;
}

const char *archstr(enum Architecture arch) {
    switch (arch) {
        case ARCH_NATIVE:
            return "native";

        case ARCH_INTERPRET:
            return "interpret";

        case ARCH_X86_64:
            return "x86_64";
    }

    return 0;
}

enum Architecture getnative() {
#ifdef __x86_64__
    return ARCH_X86_64;
#else
    return ARCH_INTERPRET;
#endif
}
