#ifndef ARCTIC_H
#define ARCTIC_H

#include <stdint.h>

enum ArcticVariableIndex {
    VARIABLE_A = 0, VARIABLE_B, VARIABLE_C,
    VARIABLE_I, VARIABLE_N,
    VARIABLE_X, VARIABLE_Y, VARIABLE_Z,
    VARIABLE_MAX
};

enum ArcticImmediateKind {
    PLAIN_IMMEDIATE, VARIABLE_IMMEDIATE, INTEGER_IMMEDIATE, NUMERIC_IMMEDIATE, SYMBOLIC_IMMEDIATE
};

struct ArcticImmediate {
    enum ArcticImmediateKind kind;
    union {
        enum ArcticVariableIndex v;
        int64_t i;
        double n;
        const char *s;
    };
};

struct ArcticOperation {
    char code;
    uint8_t bigendian;
    struct ArcticImmediate immediate;
};

union ArcticType {
    int8_t b;
    uint8_t ub;
    int16_t s;
    uint16_t us;
    int32_t w;
    uint32_t uw;
    int64_t i;
    uint64_t u;
    double d;
    uint8_t *p;
    struct ArcticOperation *f;
};

struct ArcticState {

};

int parse_arctic(struct ArcticState *state, const char *arctic);

#endif /* ARCTIC_H */
