#ifndef ARGS_H
#define ARGS_H

#include "architectures.h"

#include <linux/limits.h>

enum Behaviour {
    BEHAVIOUR_INTERPRET,
    BEHAVIOUR_JIT,
    BEHAVIOUR_ASM
};

struct Arguments {
    enum Behaviour behaviour;
    char program[PATH_MAX + 1];
    union {
        struct {
        } interpret;

        struct {
            enum Architecture arch;
        } jit;

        struct {
            enum Architecture arch;
        } assemble;
    };
};

int parse_arguments(struct Arguments *args, int argc, char *argv[]);

#endif /* ARGS_H */
