#ifndef CRITBIT_H
#define CRITBIT_H

struct CritBitTree {
    void *root;
    int count;
    void (*free_data)(void *data, int datalen);
};

void crit_bit_init(struct CritBitTree *tree, void (*free_data)(void *data, int datalen)); /* or just { 0 } if you don't need a free_data */
void crit_bit_free(struct CritBitTree *tree); /* a free tree is still initted and can be used */
int crit_bit_add(struct CritBitTree *tree, const char *key, void *data, int datalen);
int crit_bit_has(const struct CritBitTree *tree, const char *key);
void *crit_bit_get(const struct CritBitTree *tree, const char *key, int *len);
int crit_bit_del(struct CritBitTree *tree, const char *key);
int crit_bit_size(const struct CritBitTree *tree);
int crit_bit_foreach(const struct CritBitTree *tree, int (*callback)(const char*,void*,int,void*), void *data); /* returns short-circuit OR of callback value */

#endif /* CRITBIT_H */
