#ifndef JIT_H
#define JIT_H

#include "architectures.h"

/* these are what jit functions return */
typedef int (*main_func)(int, char**);

/* the implementations must implement these functions */
typedef int (*((*jit)(const char *,int)))(int, char**);

jit get_implementation(enum Architecture arch);

/* these are what the asm functions receive */
typedef void (*str_func)(const char *, void *);

void asm_implementation(enum Architecture arch, const char *source, int len, str_func cb, void *data);

#endif /* JIT_H */
